## Beagle_SDR_GPS-master.zip

=== Makefile ===
VERSION_MAJ = 1
VERSION_MIN = 332

REPO_NAME = Beagle_SDR_GPS
DEBIAN_VER = 8.5

# Caution: software update mechanism depends on format of first two lines in this file

#
# Makefile for KiwiSDR project
#
# Copyright (c) 2014-2019 John Seamons, ZL/KF6VO
#

#
# This Makefile can be run on both a build machine (I use a MacBook Pro) and the
# BeagleBone Black target (Debian release).
# Which machine you're on is figured out by this:
#
#	DEBIAN_DEVSYS = $(shell grep -q -s Debian /etc/dogtag; echo $$?)
#	DEBIAN = 0
#	NOT_DEBIAN = 1
#	DEVSYS = 2
#	ifeq ($(DEBIAN_DEVSYS),$(DEBIAN))
#		...
#	ifeq ($(DEBIAN_DEVSYS),$(DEVSYS))
#		...
#
# The '/etc/dogtag' file is present on the Beagle and not on the dev machine.
# Grep returns 0 if "Debian" is found in /etc/dogtag, 1 if it isn't and 2 if /etc/dogtag doesn't exist.
# This same mechanism is used in the wrapper shell script because device tree files need to be
# loaded only on the Beagle.
#

#
# installing FFTW:
#
#	to create /usr/local/lib/libfftw3f.a (the 'f' in '3f' means single precision)
#	Mac:
#		download the sources from fftw.org
#		./configure --enable-single
#		make
#		(sudo) make install
#	BeagleBone Black, Debian:
#		the Makefile automatically installs the package using apt-get
#


################################
# build environment detection
################################
ARCH = sitara
PLATFORM = beaglebone_black

DEBIAN_DEVSYS = $(shell grep -q -s Debian /etc/dogtag; echo $$?)
DEBIAN = 0
NOT_DEBIAN = 1
DEVSYS = 2

DEBIAN_7 = $(shell test -f /sys/devices/platform/bone_capemgr/slots; echo $$?)
UNAME = $(shell uname)


################################
# compiler/option selection
################################

ifeq ($(DEBIAN_DEVSYS),$(DEVSYS))
ifeq ($(UNAME),Darwin)
	CC = clang
	CPP = clang++
	CPP_FLAGS += -std=gnu++11
else
# try clang on your development system (if you have it) -- it's better
#	CC = clang
#	CPP = clang++

	CC = gcc
	CPP = g++
endif
endif

ifeq ($(DEBIAN_DEVSYS),$(DEBIAN))
ifeq ($(DEBIAN_7),1)
# clang 3.0 available on Debian 7.9 doesn't work
	CC = gcc
	CPP = g++
	CFLAGS += -DKIWI_DEBIAN7
# needed for iq_display.cpp et al using g++ (-std=gnu++11 isn't available on Debian 7.9)
	CPP_FLAGS += -std=gnu++0x
else
# clang(-3.5) on Debian 8.5 compiles project in 2 minutes vs 5 for gcc
	CMD_DEPS_DEBIAN = /usr/bin/clang
	CC = clang

# To use clang address sanitizer build with "make ASAN=1 OPT=O0" on target using alias "masan"
# There are shell aliases "masan" and "masan0" for these.
# Use gdb "asan" alias to set breakpoint necessary to backtrace address errors.
ifeq ($(ASAN),)
	CPP = clang++
else
	CPP = clang++-3.9
	CFLAGS += -fsanitize=address -fno-omit-frame-pointer
	#LDFLAGS += -v -fsanitize=address
	LDFLAGS += -fsanitize=address
endif

# needed for iq_display.cpp et al using clang 3.5
	CPP_FLAGS += -std=gnu++11

#	CC = gcc
#	CPP = g++
# needed for iq_display.cpp et al using g++
#	CPP_FLAGS += -std=gnu++11
endif
endif

# make the compiles fast on dev system
ifeq ($(DEBIAN_DEVSYS),$(DEVSYS))
	OPT = O0
else
#	OPT = O0
endif

# static analyzer (different from address sanitizer)
# build on devsys or target with "make SAN=1" using alias "msan"
# uses -O0 for speedup when used on target (clang on Debian seems to catch more errors than on OSX)
ifeq ($(SAN),1)
	CPP_FLAGS += -Werror --analyze -DKIWI_STATIC_ANALYSIS
	OPT = O0
endif


################################
# build files/directories
################################

# The built files (generated .cpp/.h files, binaries etc.) are placed outside of the source tree
# into the BUILD_DIR. This is so NFS can be used to share the sources between the
# development machine and the Kiwi Beagle. If the build files were also shared there would
# be file overwrites on one machine when you built on the other (and lots of unnecessary NFS copying
# back and forth. See the nfs and nfsup aliases in /root/.bashrc for NFS setup details.

BUILD_DIR = ../build
OBJ_DIR = $(BUILD_DIR)/obj
OBJ_DIR_O3 = $(OBJ_DIR)_O3
KEEP_DIR = $(BUILD_DIR)/obj_keep
GEN_DIR = $(BUILD_DIR)/gen
TOOLS_DIR = $(BUILD_DIR)/tools

PKGS = pkgs/mongoose
PKGS_O3 = pkgs/jsmn pkgs/sha256 pkgs/TNT_JAMA

PVT_EXT_DIR = ../extensions
PVT_EXT_DIRS = $(sort $(dir $(wildcard $(PVT_EXT_DIR)/*/extensions/*/*)))
INT_EXT_DIRS = $(sort $(dir $(wildcard extensions/*/*)))
EXT_DIRS = extensions $(INT_EXT_DIRS) $(PVT_EXT_DIRS)

PVT_EXTS = $(subst $(PVT_EXT_DIR)/,,$(wildcard $(PVT_EXT_DIR)/*))
INT_EXTS = $(subst /,,$(subst extensions/,,$(wildcard $(INT_EXT_DIRS))))
EXTS = $(INT_EXTS) $(PVT_EXTS)

GPS = gps gps/ka9q-fec gps/GNSS-SDRLIB
_DIRS = pru $(PKGS)
_DIRS_O3 += . $(PKGS_O3) platform/$(PLATFORM) $(EXT_DIRS) rx rx/CuteSDR rx/csdr rx/kiwi $(GPS) ui init support net web arch arch/$(ARCH)

ifeq ($(OPT),O0)
	DIRS = $(_DIRS) $(_DIRS_O3)
	DIRS_O3 =
	OBJ_DIR_WEB = $(OBJ_DIR)
else
	DIRS = $(_DIRS)
	DIRS_O3 = $(_DIRS_O3)
	OBJ_DIR_WEB = $(OBJ_DIR_O3)
endif

VPATH = $(DIRS) $(DIRS_O3)
I = -I$(GEN_DIR) $(addprefix -I,$(DIRS)) $(addprefix -I,$(DIRS_O3)) -I/usr/local/include
H = $(wildcard $(addsuffix /*.h,$(DIRS))) $(wildcard $(addsuffix /*.h,$(DIRS_O3)))
CPP_F = $(wildcard $(addsuffix /*.cpp,$(DIRS)))
CPP_F_O3 = $(wildcard $(addsuffix /*.cpp,$(DIRS_O3)))

# remove generated files
CFILES = $(subst web/web.cpp,,$(CPP_F))
CFILES_O3 = $(subst web/web.cpp,,$(CPP_F_O3))

#CFLAGS_UNSAFE_OPT = -fcx-limited-range -funsafe-math-optimizations
CFLAGS_UNSAFE_OPT = -funsafe-math-optimizations

ifeq ($(DEBIAN_DEVSYS),$(DEVSYS))
# development machine, compile simulation version
	CFLAGS += -g -MMD -DDEBUG -DDEVSYS
	LIBS = -L/usr/local/lib -lfftw3f -lfftw3
	LIBS_DEP = /usr/local/lib/libfftw3f.a /usr/local/lib/libfftw3.a
	CMD_DEPS =
	DIR_CFG = unix_env/kiwi.config
	CFG_PREFIX = dist.

else

# host machine (BBB), only build the FPGA-using version
#	CFLAGS += -mfloat-abi=softfp -mfpu=neon
	CFLAGS +=  -mfpu=neon -mtune=cortex-a8 -mcpu=cortex-a8 -mfloat-abi=hard
#	CFLAGS += -O3
	CFLAGS += -g -MMD -DDEBUG -DHOST
	LIBS = -lfftw3f -lfftw3 -lutil
	LIBS_DEP = /usr/lib/arm-linux-gnueabihf/libfftw3f.a /usr/lib/arm-linux-gnueabihf/libfftw3.a /usr/sbin/avahi-autoipd /usr/bin/upnpc
	CMD_DEPS = $(CMD_DEPS_DEBIAN) /usr/sbin/avahi-autoipd /usr/bin/upnpc /usr/bin/dig /usr/bin/pnmtopng /sbin/ethtool /usr/bin/sshpass
	DIR_CFG = /root/kiwi.config
	CFG_PREFIX =

# -lrt required for clock_gettime() on Debian 7; see clock_gettime(2) man page
ifeq ($(DEBIAN_7),1)
	LIBS += -lrt
endif

endif


################################
# "all" target must be first
################################
.PHONY: all
all: c_ext_clang_conv
	@make c_ext_clang_conv_all


################################
# package install
################################

# install packages for needed libraries or commands
# some of these are prefixed with "-" to keep update from failing if there is damage to /var/lib/dpkg/info
ifeq ($(DEBIAN_DEVSYS),$(DEBIAN))

KEYRING = $(DIR_CFG)/.keyring.dep
$(KEYRING):
ifeq ($(DEBIAN_7),1)
	cp /etc/apt/sources.list /etc/apt/sources.list.orig
	sed -e 's/ftp\.us/archive/' < /etc/apt/sources.list >/tmp/sources.list
	mv /tmp/sources.list /etc/apt/sources.list
endif
	-apt-get install debian-archive-keyring
	-apt-get update
	touch $(KEYRING)

/usr/lib/arm-linux-gnueabihf/libfftw3f.a /usr/lib/arm-linux-gnueabihf/libfftw3.a:
	apt-get -y install libfftw3-dev

/usr/bin/clang:
	apt-get -y install clang

/usr/sbin/avahi-autoipd:
	-apt-get -y install avahi-autoipd

/usr/bin/upnpc:
	-apt-get -y install miniupnpc

/usr/bin/dig:
	-apt-get -y install dnsutils

/usr/bin/pnmtopng:
	-apt-get -y install pnmtopng

/sbin/ethtool:
	-apt-get -y install ethtool

/usr/bin/sshpass:
	-apt-get -y install sshpass
endif


################################
# dependencies
################################
#ALL_DEPS = pru/pru_realtime.bin
#SRC_DEPS = Makefile
SRC_DEPS = 
BIN_DEPS = KiwiSDR.rx4.wf4.bit KiwiSDR.rx8.wf2.bit KiwiSDR.rx3.wf3.bit
#BIN_DEPS = 
DEVEL_DEPS = $(OBJ_DIR_WEB)/web_devel.o $(KEEP_DIR)/edata_always.o $(KEEP_DIR)/edata_always2.o
EMBED_DEPS = $(OBJ_DIR_WEB)/web_embed.o $(OBJ_DIR)/edata_embed.o $(KEEP_DIR)/edata_always.o  $(KEEP_DIR)/edata_always2.o
EXTS_DEPS = $(OBJ_DIR)/ext_init.o

GEN_ASM = $(GEN_DIR)/kiwi.gen.h verilog/kiwi.gen.vh
OUT_ASM = $(GEN_DIR)/kiwi.aout
GEN_VERILOG = $(addprefix verilog/rx/,cic_rx1_12k.vh cic_rx1_20k.vh cic_rx2_12k.vh cic_rx2_20k.vh cic_rx3_12k.vh cic_rx3_20k.vh cic_wf1.vh cic_wf2.vh)
GEN_NOIP2 = $(GEN_DIR)/noip2
ALL_DEPS += $(GEN_ASM) $(OUT_ASM) $(GEN_VERILOG) $(CMD_DEPS) $(GEN_NOIP2)


################################
# conversion to clang
################################

# NB: afterwards have to rerun make to pickup filename change!
ifneq ($(PVT_EXT_DIRS),)
PVT_EXT_C_FILES = $(shell find $(PVT_EXT_DIRS) -name '*.c' -print)
endif

.PHONY: c_ext_clang_conv
ifeq ($(PVT_EXT_C_FILES),)
c_ext_clang_conv:
#	@echo no installed extensions with files needing conversion from .c to .cpp for clang compatibility
else
c_ext_clang_conv:
#	@echo PVT_EXT_C_FILES = $(PVT_EXT_C_FILES)
	@echo convert installed extension .c files to .cpp for clang compatibility
	find $(PVT_EXT_DIRS) -name '*.c' -exec mv '{}' '{}'pp \;
endif

.PHONY: c_ext_clang_conv_all
c_ext_clang_conv_all: $(KEYRING) $(LIBS_DEP) $(ALL_DEPS) $(BUILD_DIR)/kiwi.bin


################################
# Makefile dependencies
################################

# dependence on VERSION_{MAJ,MIN}
MAKEFILE_DEPS = main.cpp
MF_FILES = $(addsuffix .o,$(basename $(notdir $(MAKEFILE_DEPS))))
MF_OBJ = $(addprefix $(OBJ_DIR)/,$(MF_FILES))
MF_O3 = $(wildcard $(addprefix $(OBJ_DIR_O3)/,$(MF_FILES)))
$(MF_OBJ) $(MF_O3): Makefile


################################
# PRU (not currently used)
################################
PASM_INCLUDES = $(wildcard pru/pasm/*.h)
PASM_SOURCE = $(wildcard pru/pasm/*.c)
pas: $(PASM_INCLUDES) $(PASM_SOURCE) Makefile
	$(CC) -Wall -D_UNIX_ -I./pru/pasm $(PASM_SOURCE) -o pas

pru/pru_realtime.bin: pas pru/pru_realtime.p pru/pru_realtime.h pru/pru_realtime.hp
	(cd pru; ../pas -V3 -b -L -l -D_PASM_ -D$(SETUP) pru_realtime.p)


################################
# Verilog generator
################################
$(GEN_VERILOG): $(GEN_DIR)/kiwi.gen.h verilog/rx/cic_gen.c
ifeq ($(DEBIAN_DEVSYS),$(DEVSYS))
	(cd verilog/rx; make)
endif


################################
# FPGA embedded CPU
################################
$(GEN_ASM): kiwi.config $(wildcard e_cpu/asm/*)
	(cd e_cpu; make)
$(OUT_ASM): $(wildcard e_cpu/*.asm)
	(cd e_cpu; make no_gen)


################################
# noip.com DDNS DUC
################################
$(GEN_NOIP2): pkgs/noip2/noip2.c
	(cd pkgs/noip2; make)


################################
# web server content
################################

#
# How the file optimization strategy works:
#
# FIXME
#	talk about: optim website used, NFS_READ_ONLY, EDATA_DEVEL bypass mode (including -fopt argument)
#	x should not be embedding version # in min file, but adding on demand like plain file
#	what to do about version number in .gz files though?
#	no "-zip" for html files because of possible %[] substitution (replace %[] substitutions)
#
# TODO
#	x concat embed
#	EDATA_ALWAYS/2
#	x jpg/png crush in file_optim
#	x clean target that removes .min .gz
#
# CHECK
#	does google analytics html head insert still work?
#	x ant_switch still works?
#	x update from v1.2 still works?
#	mobile works okay?
#
#
# 1) file_optim program is used to create minified and possibly gzipped versions of web server
#	content files (e.g. .js .css .html .jpg .png) Because the optimized versions of individual
#	files are included in the distro the minimization process, which uses an external website and
#	is very time consuming, is not performed by individual Kiwis as part of the update process.
#	But file_optim is run as part of the standard Makefile rules to account for any changes a user
#	may make as part of their own development (i.e. so a make install will continue to work for them)
#
# 2) Web server code has been modified to lookup optimized alternatives first, i.e. a reference to
