=== extensions/SSTV/Makefile ===
#FILES_ALWAYS2 += extensions/SSTV/s1.test.pattern.au
FILES_ALWAYS2 += extensions/SSTV/s2.test.pattern.au
#FILES_ALWAYS2 += extensions/SSTV/r24.test.pattern.au
#FILES_ALWAYS2 += extensions/SSTV/r36.test.pattern.au
#FILES_ALWAYS2 += extensions/SSTV/r36.color.bars.au
#FILES_ALWAYS2 += extensions/SSTV/r72.test.pattern.au
#FILES_ALWAYS2 += extensions/SSTV/pd50.au
#FILES_ALWAYS2 += extensions/SSTV/pd90.au
#FILES_ALWAYS2 += extensions/SSTV/w2120.au
#FILES_ALWAYS2 += extensions/SSTV/w2180.au
