=== pkgs/noip2/Makefile ===
BUILD_DIR = ../../../build
GEN_DIR = $(BUILD_DIR)/gen

${GEN_DIR}/noip2: Makefile noip2.c 
	gcc -Wall -g -Dlinux noip2.c -o ${GEN_DIR}/noip2

clean: 
	rm -f ${GEN_DIR}/noip2*

clean_dist: clean
	rm -f NO-*
