=== unix_env/bb.org-overlays/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-


%:
	dh $@ 

clean::
	rm -rf build build-stamp configure-stamp build/ MANIFEST
	dh_clean
